#include "gtk_draw.h"

/* ꤷɸΥѥåȤϢ³Ƽ */
void s_point( guchar** pixel, Palet* palet )
{
  palet->red = ( *pixel )[0];
  palet->green = ( *pixel )[1];
  palet->blue = ( *pixel )[2];

  *pixel += 3;
}

/* ꤷɸΥѥåȤ */
void point( DrawingArea* draw, int x, int y, Palet* palet )
{
  guchar *pixel;
  int rowstride = gdk_pixbuf_get_rowstride( draw->pixbuf );
  int n_channels = gdk_pixbuf_get_n_channels( draw->pixbuf );

  pixel = ( draw->pixbuf_p ) + y * rowstride + x * n_channels;
  s_point( &pixel, palet );
}

/* ꤷɸ˥ɥåȤ褹 */
void s_pset( guchar** pixel, Palet* palet )
{
  ( *pixel )[0] = palet->red;
  ( *pixel )[1] = palet->green;
  ( *pixel )[2] = palet->blue;

  *pixel += 3;
}

/* ꤷɸ˥ɥåȤ褹 */
void pset( DrawingArea* draw, int x, int y, Palet* palet )
{
  guchar *pixel;
  int rowstride = gdk_pixbuf_get_rowstride( draw->pixbuf );
  int n_channels = gdk_pixbuf_get_n_channels( draw->pixbuf );

  pixel = ( draw->pixbuf_p ) + y * rowstride + x * n_channels;
  s_pset( &pixel, palet );
}

/* ĤΥѥåȤ */
int check_color( Palet* col1, Palet* col2 )
{
  return( ( col1->red == col2->red &&
	    col1->green == col2->green &&
	    col1->blue == col2->blue )
	  ? 0 : 1 );
}

/* ѥåƱΤβû */
void add_palet( Palet* p, Palet* inc_p )
{
  p->red += inc_p->red;
  p->green += inc_p->green;
  p->blue += inc_p->blue;
}

/* ѥåƱΤθ */
void sub_palet( Palet* p, Palet* dec_p )
{
  p->red -= dec_p->red;
  p->green -= dec_p->green;
  p->blue -= dec_p->blue;
}

/* PALET -> INTEGER Ѵ */
int Palet2Int( Palet* palet )
{
  return( ( (int)( palet->red ) << 16 )
	  | (int)( palet->green ) << 8
	  | (int)( palet->blue ) );
}

/* INTEGER -> PALET Ѵ */
void Int2Palet( Palet* palet, int color )
{
  palet->red = ( color >> 16 ) & 0xFF;
  palet->green = ( color >> 8 ) & 0xFF;
  palet->blue = ( color >> 0 ) & 0xFF;
}

/* pixbufξ򥳥ԡ */
void copy_pixbuf_info( DrawingArea* dest, DrawingArea* src )
{
  src->width = gdk_pixbuf_get_width( dest->pixbuf );
  src->height = gdk_pixbuf_get_height( dest->pixbuf );

  if ( src->pixbuf == NULL )
    src->pixbuf = gdk_pixbuf_new( GDK_COLORSPACE_RGB, FALSE,
				  gdk_pixbuf_get_bits_per_sample( dest->pixbuf ),
				  src->width, src->height );

  src->pixbuf_p = gdk_pixbuf_get_pixels( src->pixbuf );

  int rowstride = gdk_pixbuf_get_rowstride( src->pixbuf );
  int n_channels = gdk_pixbuf_get_n_channels( src->pixbuf );
  src->pixbuf_xsize = src->width * n_channels;
  src->pixbuf_xmod = rowstride - src->pixbuf_xsize;
}

/* Υ٥ */
gint expose_event( GtkWidget *widget, GdkEventExpose *event, gpointer pixmap )
{
  /* Refresh buffer */
  gdk_draw_pixmap( widget->window, widget->style->fg_gc[GTK_STATE_NORMAL],
		   GDK_PIXMAP( pixmap ),
		   event->area.x, event->area.y,
		   event->area.x, event->area.y,
		   event->area.width, event->area.height );

  return( FALSE );
}

/* quit : gtkå롼פȴФ */
gint quit()
{
  gtk_exit( 0 );

  return( FALSE );
}

/* ɽ */
int show_image( char* filename, DrawingArea* draw, char* title )
{
  GtkWidget *window;
  GdkPixbuf *pixbuf;

  /* TOP LEVEL WINDOW */
  gtk_widget_push_visual( gdk_rgb_get_visual() );
  gtk_widget_push_colormap( gdk_rgb_get_cmap() );
  window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
  gtk_widget_pop_visual();
  gtk_widget_pop_colormap();

  /* DRAWING AREA */
  draw->drawing_area = gtk_drawing_area_new();
  gtk_container_add( GTK_CONTAINER( window ), draw->drawing_area );
  gtk_widget_show( draw->drawing_area );

  /* "destroy" SIGNAL */
  gtk_signal_connect( GTK_OBJECT( window ), "destroy", GTK_SIGNAL_FUNC( quit ), NULL );

  if ( filename != NULL ) {
    pixbuf = gdk_pixbuf_new_from_file( filename, NULL );
    if ( pixbuf == NULL ) return( 0 );

    draw->pixbuf = gdk_pixbuf_new( GDK_COLORSPACE_RGB, FALSE,
				   gdk_pixbuf_get_bits_per_sample( pixbuf ),
				   gdk_pixbuf_get_width( pixbuf ),
				   gdk_pixbuf_get_height( pixbuf ) );
    gdk_pixbuf_copy_area( pixbuf, 0, 0, gdk_pixbuf_get_width( pixbuf ), gdk_pixbuf_get_height( pixbuf ),
			  draw->pixbuf, 0, 0 );
    gdk_pixbuf_unref( pixbuf );

    copy_pixbuf_info( draw, draw );
  }

  gtk_window_set_title( GTK_WINDOW( window ), title );
  gtk_widget_show( window );

  gtk_drawing_area_size( GTK_DRAWING_AREA( draw->drawing_area ), draw->width, draw->height );

  draw->pixmap = gdk_pixmap_new( draw->drawing_area->window, draw->width, draw->height, -1 );
  if ( filename != NULL )
    gdk_pixbuf_render_to_drawable( draw->pixbuf, draw->pixmap, draw->drawing_area->style->fg_gc[GTK_STATE_NORMAL],
				   0, 0, 0, 0, draw->width, draw->height, GDK_RGB_DITHER_NORMAL, 0, 0);

  g_signal_connect( G_OBJECT( draw->drawing_area ), "expose_event", G_CALLBACK( expose_event ), draw->pixmap );

  return( 1 );
}
