#ifndef JPEG_GLOBAL_H
#define JPEG_GLOBAL_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <math.h>
#include <sys/time.h>
#include <limits.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "gtk_draw.h"

enum SIZE_TYPE {
  MCU_SIZE = 8,  /* MCU礭 */
  YUV_SIZE = 3,  /* YUVʬο(Y,U,V) */
  SAMP_SIZE = 3, /* ץ󥰤μ */
};

enum IDX {
  Y_IDX = 0,     /* YʬΥǥå */
  U_IDX = 1,     /* UʬΥǥå */
  V_IDX = 2,     /* VʬΥǥå */
};

/* MCU¤ */
typedef struct Mcu
{
  int d[MCU_SIZE][MCU_SIZE];
} Mcu;

/* ɸϹ¤ */
typedef struct Coord
{
  int x;
  int y;
} Coord;

void rgb2yuv( DrawingArea*, double** );
void yuv2rgb( DrawingArea*, double** );
void calcCoeff();
Mcu* mcu_encode( double*, Mcu*, Coord*, Coord* );
void mcu_decode( Mcu*, double*, Coord*, Coord* );
void quantize( Mcu*, Mcu*, int, int );
void deQuantize( Mcu*, Mcu*, int, int );
unsigned char* dc_encode( Mcu*, Mcu*, unsigned char*, unsigned char*, int, int );
unsigned char* ac_encode( Mcu*, Mcu*, unsigned char*, unsigned char*, int, int );
unsigned char* dc_decode( unsigned char*, unsigned char*, Mcu*, Mcu*, int );
unsigned char* ac_decode( unsigned char*, unsigned char*, Mcu*, Mcu*, int );

void showMCU( DrawingArea*, Mcu*, Coord* );

#endif
